(function (d3) {
	'use strict';
  var tempCounter = 0;
  var appleRemovalRefreshCounter = 0;
  const colorScale = d3.scaleOrdinal()
    .domain(['apple', 'lemon'])
    .range(['#c11d1d', '#eae600']);

  const radiusScale = d3.scaleOrdinal()
    .domain(['apple', 'lemon'])
    .range([80, 50]);
	
	var data = [0.243, 0.584, 0.987, 0.153, 0.433];
	var extent = d3.extent(data);

	var fontScale = d3.scaleLinear()
	  .domain(extent)
	  .range([0, 600]);
  
   const xPosition = (d, i) => i * 180 + 100;
	
   const fruitBowl = (selection, props) => {
	chartHeight = props.height;
    const { fruits, height } = props;
    
    const bowl = selection.selectAll('rect')
      .data([null])
      .enter().append('rect')
        .attr('y', 110)
        .attr('width', 920)
        .attr('height', 300)
        .attr('rx', 300 / 2);
    
	const groups = selection.selectAll('g')
      .data(fruits);
	  
	 groups.exit().remove();
	 
    const groupsEnter = groups.enter().append('g');
	groupsEnter
      .merge(groups)
		.attr("class",function(d,i){
			return "classGroup"+i;
		})
        .attr('transform', (d, i) =>
          `translate(${i * 180 + 100},${height / 2})`
        );
    
	const circles = groupsEnter.append('circle')
        .attr('r', 0)
		.attr("class",function(k,i){
			return "classCircle"+i;
	   })      
        .attr('fill', d => colorScale(d.type))
      .transition().duration(1000)
        //.attr('cx', xPosition)
        .attr('r', d => radiusScale(d.type));
    
		// add text
		groupsEnter.append('text')
      .attr("class",function(k,i){
			return "classText"+i;
	   }) 
        .text(d => d.type)
		.style("font-size", function(k){
			return "0px";
		})
        .attr('y', 120)
		.transition().duration(1000)    
		.style("font-size", function(k){
			return "40px";//fontScale(k.type);
		})
		
	// hide 5th fruit
	d3.select(".classCircle4")
		.attr('r', 0)
   .attr("class",function(k,i){
		return "classCircle"+i;
	   })      
        .attr('fill', d => colorScale(d.type))
      .transition().duration(1000)
        .attr('r', d => radiusScale(d.type))
      .transition().duration(2000)
        .attr('r', 0);
	
	// hide circle 5 text
	d3.select(".classText4")
		.style("font-size", "0px")
	   .attr("class",function(k,i){
			return "classText"+i;
		   })      
        //.attr('fill', d => colorScale(d.type))
      .transition().duration(1000)
        .style("font-size", function(k){
			return "40px";//fontScale(k.type);
		})
      .transition().duration(2000)
        .style("font-size", "0px");	
  };

  const svg = d3.select('svg');
  let fruits;
  var chartHeight = 0;

  const render = () => {
	
    fruitBowl(svg, {
      fruits,
      height: +svg.attr('height')
    });
  };

  // Buy 5 apples.
  const makeFruit = type => ({ type });
  fruits = d3.range(5).map(() => makeFruit('apple'));
  render();
    
  // Eat an apple.
  setTimeout(() => {
     	// change 3rd fruit type 
	d3.select(".classCircle2")
	.transition().duration(1000)
		.attr('r', d => radiusScale("apple"))
   .attr("class",function(k,i){
		return "class"+i;
	   }) 
      .transition().duration(2000)
	   .attr('fill', d => colorScale("lemon"))
        .attr('r', d => radiusScale("lemon"))
      .transition().duration(3000)
        .attr('r', function(k){ 
			return radiusScale("lemon");
		});
   
		 d3.select(".classText2").transition().duration(2000).text("apple").transition().duration(2000).text("lemon");
   
  }, 1000);
  
  // Replacing an apple with a lemon.
  setTimeout(() => {
   
   // move node 2 to left side   
   //d3.select(".classGroup1")
	   //.transition().duration(7000).remove();
	         
	   d3.select(".classGroup2")
	   .transition().duration(1000)
	   .attr('transform', function(d, i) {
			//d3.select(".classGroup1").remove();
         return `translate(${1 * 180 + 100},${chartHeight / 2})`
	   });
			
	   d3.select(".classGroup3")
	   .transition().duration(1000)
	   .attr('transform', (d, i) =>
          `translate(${2 * 180 + 100},${chartHeight / 2})`
        );
		
		d3.select(".classGroup4").remove();
   
  }, 4000);
  
  // Replacing an apple with a lemon.
  setTimeout(() => {
   
	d3.select(".classCircle1")
		.attr('r', d => radiusScale(d.type))
	.attr("class",function(k,i){
			return "classCircle"+i;
	   })
        .attr('fill', d => colorScale(d.type))
      .transition().duration(1000)
        .attr('r', d => radiusScale(d.type))
      .transition().duration(2000)
        .attr('r', 0);		
		
		d3.select(".classText1")
		
	   .attr("class",function(k,i){
			return "classText"+i;
		   })
      .transition().duration(1000)
        .style("font-size", function(k){
			return "40px";
		})
      .transition().duration(2000)
        .style("font-size", "0px");	
  
   d3.select(".classGroup4").remove();
   d3.select(".classGroup1").transition().duration(3000).remove();
   
  }, 2500);

}(d3));
